/*
 * $Id$
 *
 * Copyright (C) 2009, 2010 Elias Norberg, Patrik Sternudd
 *
 * This file is part of TDEPS.
 *
 * TDEPS is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * TDEOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TDEPS.  If not, see <http://www.gnu.org/licenses/>.
 */
#include <iostream>
#include <string.h>
#include <malloc.h>
#include "linked_list.h"


namespace linked_list{

list::list()
{
	first_node = NULL;
}

list::~list()
{
	node *tmp;

	while( first_node != NULL ){
		tmp = first_node->next;

		free(first_node->key);
		free(first_node->data);
		delete first_node;

		first_node = tmp;
	}

}

void list::add( const char *key, const char *data )
{
	node *tmp;

	if( this->first_node == NULL ){
		this->first_node = new node;
		this->first_node->key = strdup(key);
		this->first_node->data = strdup(data);
		this->first_node->next = NULL;

		return;
	}

	for( tmp = this->first_node; tmp->next != NULL; tmp = tmp->next );

	tmp->next = new node;
	tmp->next->key = strdup(key);
	tmp->next->data = strdup(data);
	tmp->next->next = NULL;
}

char *list::get( const char *key )
{
	node *tmp;

	for( tmp = first_node; tmp != NULL ; tmp = tmp->next ){
		if( strcmp(tmp->key, key) == 0 )
			return tmp->data;
	}

	return NULL;
}

}

